Index: src/Actions/MapOfActions.cpp
===================================================================
--- src/Actions/MapOfActions.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MapOfActions.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -480,4 +643,243 @@
 }
 
+bool MapOfActions::isCurrentValuePresent(const char *name) const
+{
+  return (CurrentValue.find(name) != CurrentValue.end());
+}
+
+void MapOfActions::queryCurrentValue(const char * name, class atom * &_T)
+{
+  int atomID = -1;
+  if (typeid( atom ) == *TypeMap[name]) {
+    if (CurrentValue.find(name) == CurrentValue.end())
+      throw MissingValueException(__FILE__, __LINE__);
+    atomID = lexical_cast<int>(CurrentValue[name].c_str());
+    CurrentValue.erase(name);
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+  _T = World::getInstance().getAtom(AtomById(atomID));
+}
+
+void MapOfActions::queryCurrentValue(const char * name, const element * &_T)  {
+  int Z = -1;
+  if (typeid(const element ) == *TypeMap[name]) {
+    if (CurrentValue.find(name) == CurrentValue.end())
+      throw MissingValueException(__FILE__, __LINE__);
+    Z = lexical_cast<int>(CurrentValue[name].c_str());
+    CurrentValue.erase(name);
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+  _T = World::getInstance().getPeriode()->FindElement(Z);
+}
+
+void MapOfActions::queryCurrentValue(const char * name, class molecule * &_T) {
+  int molID = -1;
+  if (typeid( molecule ) == *TypeMap[name]) {
+    if (CurrentValue.find(name) == CurrentValue.end())
+      throw MissingValueException(__FILE__, __LINE__);
+    molID = lexical_cast<int>(CurrentValue[name].c_str());
+    CurrentValue.erase(name);
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+  _T = World::getInstance().getMolecule(MoleculeById(molID));
+}
+
+void MapOfActions::queryCurrentValue(const char * name, class Box &_T) {
+  Matrix M;
+  double tmp;
+  if (typeid( BoxValue ) == *TypeMap[name]) {
+    if (CurrentValue.find(name) == CurrentValue.end())
+      throw MissingValueException(__FILE__, __LINE__);
+    std::istringstream stream(CurrentValue[name]);
+    stream >> tmp;
+    M.set(0,0,tmp);
+    stream >> tmp;
+    M.set(0,1,tmp);
+    M.set(1,0,tmp);
+    stream >> tmp;
+    M.set(0,2,tmp);
+    M.set(2,0,tmp);
+    stream >> tmp;
+    M.set(1,1,tmp);
+    stream >> tmp;
+    M.set(1,2,tmp);
+    M.set(2,1,tmp);
+    stream >> tmp;
+    M.set(2,2,tmp);
+    _T = M;
+    CurrentValue.erase(name);
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void MapOfActions::queryCurrentValue(const char * name, class Vector &_T) {
+  if (typeid( VectorValue ) == *TypeMap[name]) {
+    std::istringstream stream(CurrentValue[name]);
+    CurrentValue.erase(name);
+    stream >> _T[0];
+    stream >> _T[1];
+    stream >> _T[2];
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void MapOfActions::queryCurrentValue(const char * name, std::vector<atom *>&_T)
+{
+  int atomID = -1;
+  atom *Walker = NULL;
+  if (typeid( std::vector<atom *> ) == *TypeMap[name]) {
+    if (CurrentValue.find(name) == CurrentValue.end())
+      throw MissingValueException(__FILE__, __LINE__);
+    std::istringstream stream(CurrentValue[name]);
+    CurrentValue.erase(name);
+    while (!stream.fail()) {
+      stream >> atomID >> ws;
+      Walker = World::getInstance().getAtom(AtomById(atomID));
+      if (Walker != NULL)
+        _T.push_back(Walker);
+      atomID = -1;
+      Walker = NULL;
+    }
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void MapOfActions::queryCurrentValue(const char * name, std::vector<const element *>&_T)
+{
+  int Z = -1;
+  const element *elemental = NULL;
+  if (typeid( std::vector<const element *> ) == *TypeMap[name]) {
+    if (CurrentValue.find(name) == CurrentValue.end())
+      throw MissingValueException(__FILE__, __LINE__);
+    std::istringstream stream(CurrentValue[name]);
+    CurrentValue.erase(name);
+    while (!stream.fail()) {
+      stream >> Z >> ws;
+      elemental = World::getInstance().getPeriode()->FindElement(Z);
+      if (elemental != NULL)
+        _T.push_back(elemental);
+      Z = -1;
+    }
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void MapOfActions::queryCurrentValue(const char * name, std::vector<molecule *>&_T)
+{
+  int molID = -1;
+  molecule *mol = NULL;
+  if (typeid( std::vector<molecule *> ) == *TypeMap[name]) {
+    if (CurrentValue.find(name) == CurrentValue.end())
+      throw MissingValueException(__FILE__, __LINE__);
+    std::istringstream stream(CurrentValue[name]);
+    CurrentValue.erase(name);
+    while (!stream.fail()) {
+      stream >> molID >> ws;
+      mol = World::getInstance().getMolecule(MoleculeById(molID));
+      if (mol != NULL)
+        _T.push_back(mol);
+      molID = -1;
+      mol = NULL;
+    }
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+
+void MapOfActions::setCurrentValue(const char * name, class atom * &_T)
+{
+  if (typeid( atom ) == *TypeMap[name]) {
+    std::ostringstream stream;
+    stream << _T->getId();
+    CurrentValue[name] = stream.str();
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void MapOfActions::setCurrentValue(const char * name, const element * &_T)
+{
+  if (typeid(const element ) == *TypeMap[name]) {
+    std::ostringstream stream;
+    stream << _T->Z;
+    CurrentValue[name] = stream.str();
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void MapOfActions::setCurrentValue(const char * name, class molecule * &_T)
+{
+  if (typeid( molecule ) == *TypeMap[name]) {
+    std::ostringstream stream;
+    stream << _T->getId();
+    CurrentValue[name] = stream.str();
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void MapOfActions::setCurrentValue(const char * name, class Box &_T)
+{
+  const Matrix &M = _T.getM();
+  if (typeid( BoxValue ) == *TypeMap[name]) {
+    std::ostringstream stream;
+    stream << M.at(0,0) << " ";
+    stream << M.at(0,1) << " ";
+    stream << M.at(0,2) << " ";
+    stream << M.at(1,1) << " ";
+    stream << M.at(1,2) << " ";
+    stream << M.at(2,2) << " ";
+    CurrentValue[name] = stream.str();
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void MapOfActions::setCurrentValue(const char * name, class Vector &_T)
+{
+  if (typeid( VectorValue ) == *TypeMap[name]){
+    std::ostringstream stream;
+    stream << _T[0] << " ";
+    stream << _T[1] << " ";
+    stream << _T[2] << " ";
+    CurrentValue[name] = stream.str();
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void MapOfActions::setCurrentValue(const char * name, std::vector<atom *>&_T)
+{
+  if (typeid( std::vector<atom *> ) == *TypeMap[name]) {
+    std::ostringstream stream;
+    for (std::vector<atom *>::iterator iter = _T.begin(); iter != _T.end(); ++iter) {
+      stream << (*iter)->getId() << " ";
+    }
+    CurrentValue[name] = stream.str();
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void MapOfActions::setCurrentValue(const char * name, std::vector<const element *>&_T)
+{
+  if (typeid( std::vector<const element *> ) == *TypeMap[name]) {
+    std::ostringstream stream;
+    for (std::vector<const element *>::iterator iter = _T.begin(); iter != _T.end(); ++iter) {
+      stream << (*iter)->Z << " ";
+    }
+    CurrentValue[name] = stream.str();
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+void MapOfActions::setCurrentValue(const char * name, std::vector<molecule *>&_T)
+{
+  if (typeid( std::vector<molecule *> ) == *TypeMap[name]) {
+    std::ostringstream stream;
+    for (std::vector<molecule *>::iterator iter = _T.begin(); iter != _T.end(); ++iter) {
+      stream << (*iter)->getId() << " ";
+    }
+    CurrentValue[name] = stream.str();
+  } else
+    throw IllegalTypeException(__FILE__,__LINE__);
+}
+
+
 
 void MapOfActions::populateActions()
@@ -485,9 +887,13 @@
   new AnalysisMolecularVolumeAction();
   new AnalysisPairCorrelationAction();
+  new AnalysisPointCorrelationAction();
   new AnalysisPrincipalAxisSystemAction();
+  new AnalysisSurfaceCorrelationAction();
 
   new AtomAddAction();
   new AtomChangeElementAction();
   new AtomRemoveAction();
+  new AtomRotateAroundOriginByAngleAction();
+  new AtomTranslateAction();
 
   new CommandLineBondLengthTableAction();
@@ -506,4 +912,5 @@
   new MoleculeFillWithMoleculeAction();
   new MoleculeLinearInterpolationofTrajectoriesAction();
+  new MoleculeRotateAroundSelfByAngleAction();
   new MoleculeRotateToPrincipalAxisSystemAction();
   new MoleculeSaveAdjacencyAction();
@@ -511,9 +918,31 @@
   new MoleculeSaveTemperatureAction();
   new MoleculeSuspendInWaterAction();
-  new MoleculeTranslateAction();
   new MoleculeVerletIntegrationAction();
 
   new ParserLoadXyzAction();
   new ParserSaveXyzAction();
+
+  new SelectionClearAllAtomsAction();
+  new SelectionClearAllMoleculesAction();
+  new SelectionAllAtomsAction();
+  new SelectionAllAtomsInsideCuboidAction();
+  new SelectionAllAtomsInsideSphereAction();
+  new SelectionAllAtomsOfMoleculeAction();
+  new SelectionAllMoleculesAction();
+  new SelectionAtomByElementAction();
+  new SelectionAtomByIdAction();
+  new SelectionMoleculeByIdAction();
+  new SelectionMoleculeByFormulaAction();
+  new SelectionMoleculeOfAtomAction();
+  new SelectionNotAllAtomsAction();
+  new SelectionNotAllAtomsInsideCuboidAction();
+  new SelectionNotAllAtomsInsideSphereAction();
+  new SelectionNotAllAtomsOfMoleculeAction();
+  new SelectionNotAllMoleculesAction();
+  new SelectionNotAtomByElementAction();
+  new SelectionNotAtomByIdAction();
+  new SelectionNotMoleculeByFormulaAction();
+  new SelectionNotMoleculeByIdAction();
+  new SelectionNotMoleculeOfAtomAction();
 
   new TesselationConvexEnvelopeAction();
@@ -527,5 +956,4 @@
   new WorldInputAction();
   new WorldOutputAction();
-  new WorldRemoveSphereOfAtomsAction();
   new WorldRepeatBoxAction();
   new WorldScaleBoxAction();
@@ -535,5 +963,4 @@
 }
 
-
 /** Adds all options to the CommandLineParser.
  *
@@ -545,6 +972,6 @@
     for (set<string>::iterator OptionRunner = ListRunner->first->begin(); OptionRunner != ListRunner->first->end(); ++OptionRunner) {
       if (hasValue(*OptionRunner)) {
-        DoLog(0) && (Log() << Verbose(0) << "Adding option " << *OptionRunner << " with type " << TypeMap[*OptionRunner] << " to CommandLineParser." << endl);
-           switch((enum OptionTypes) TypeMap[*OptionRunner]) {
+        DoLog(1) && (Log() << Verbose(1) << "Adding option " << *OptionRunner << " with type " << TypeMap[*OptionRunner]->name() << " to CommandLineParser." << endl);
+           switch(TypeEnumMap[TypeMap[*OptionRunner]]) {
           default:
           case None:
@@ -556,6 +983,6 @@
             ListRunner->second->add_options()
               (getKeyAndShortForm(*OptionRunner).c_str(),
-                  DefaultValue.find(*OptionRunner) != DefaultValue.end() ?
-                        po::value< bool >()->default_value(atoi(DefaultValue[*OptionRunner].c_str())) :
+                  CurrentValue.find(*OptionRunner) != CurrentValue.end() ?
+                        po::value< bool >()->default_value(lexical_cast<int>(CurrentValue[*OptionRunner].c_str())) :
                         po::value< bool >(),
                   getDescription(*OptionRunner).c_str())
@@ -565,5 +992,5 @@
             ListRunner->second->add_options()
               (getKeyAndShortForm(*OptionRunner).c_str(),
-                  po::value<BoxValue>()->multitoken(),
+                  po::value<BoxValue>(),
                   getDescription(*OptionRunner).c_str())
               ;
@@ -572,11 +999,11 @@
             ListRunner->second->add_options()
               (getKeyAndShortForm(*OptionRunner).c_str(),
-                  DefaultValue.find(*OptionRunner) != DefaultValue.end() ?
-                        po::value< int >()->default_value(atoi(DefaultValue[*OptionRunner].c_str())) :
+                  CurrentValue.find(*OptionRunner) != CurrentValue.end() ?
+                        po::value< int >()->default_value(lexical_cast<int>(CurrentValue[*OptionRunner].c_str())) :
                         po::value< int >(),
                   getDescription(*OptionRunner).c_str())
               ;
             break;
-          case ListOfInts:
+          case ListOfIntegers:
             ListRunner->second->add_options()
               (getKeyAndShortForm(*OptionRunner).c_str(),
@@ -588,6 +1015,6 @@
             ListRunner->second->add_options()
               (getKeyAndShortForm(*OptionRunner).c_str(),
-                  DefaultValue.find(*OptionRunner) != DefaultValue.end() ?
-                        po::value< double >()->default_value(atof(DefaultValue[*OptionRunner].c_str())) :
+                  CurrentValue.find(*OptionRunner) != CurrentValue.end() ?
+                        po::value< double >()->default_value(lexical_cast<double>(CurrentValue[*OptionRunner].c_str())) :
                         po::value< double >(),
                   getDescription(*OptionRunner).c_str())
@@ -604,11 +1031,11 @@
             ListRunner->second->add_options()
               (getKeyAndShortForm(*OptionRunner).c_str(),
-                  DefaultValue.find(*OptionRunner) != DefaultValue.end() ?
-                        po::value< std::string >()->default_value(DefaultValue[*OptionRunner]) :
+                  CurrentValue.find(*OptionRunner) != CurrentValue.end() ?
+                        po::value< std::string >()->default_value(CurrentValue[*OptionRunner]) :
                         po::value< std::string >(),
                   getDescription(*OptionRunner).c_str())
               ;
             break;
-          case ListOfString:
+          case ListOfStrings:
             ListRunner->second->add_options()
               (getKeyAndShortForm(*OptionRunner).c_str(),
@@ -617,30 +1044,44 @@
               ;
             break;
-          case Axis:
-            ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(),
-                  DefaultValue.find(*OptionRunner) != DefaultValue.end() ?
-                        po::value< int >()->default_value(atoi(DefaultValue[*OptionRunner].c_str())) :
+          case Vector:
+            ListRunner->second->add_options()
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  po::value<VectorValue>(),
+                  getDescription(*OptionRunner).c_str())
+              ;
+            break;
+          case ListOfVectors:
+            ListRunner->second->add_options()
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  po::value< vector<VectorValue> >()->multitoken(),
+                  getDescription(*OptionRunner).c_str())
+              ;
+            break;
+          case Molecule:
+            ListRunner->second->add_options()
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  CurrentValue.find(*OptionRunner) != CurrentValue.end() ?
+                        po::value< int >()->default_value(lexical_cast<int>(CurrentValue[*OptionRunner].c_str())) :
                         po::value< int >(),
                   getDescription(*OptionRunner).c_str())
               ;
             break;
-          case Vector:
-            ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(),
-                  po::value<VectorValue>(),
-                  getDescription(*OptionRunner).c_str())
-              ;
-            break;
-          case Molecule:
-            ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(),
-                  DefaultValue.find(*OptionRunner) != DefaultValue.end() ?
-                        po::value< int >()->default_value(atoi(DefaultValue[*OptionRunner].c_str())) :
+          case ListOfMolecules:
+            ListRunner->second->add_options()
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  po::value< vector<int> >()->multitoken(),
+                  getDescription(*OptionRunner).c_str())
+              ;
+            break;
+          case Atom:
+            ListRunner->second->add_options()
+              (getKeyAndShortForm(*OptionRunner).c_str(),
+                  CurrentValue.find(*OptionRunner) != CurrentValue.end() ?
+                        po::value< int >()->default_value(lexical_cast<int>(CurrentValue[*OptionRunner].c_str())) :
                         po::value< int >(),
                   getDescription(*OptionRunner).c_str())
               ;
             break;
-          case ListOfMolecules:
+          case ListOfAtoms:
             ListRunner->second->add_options()
               (getKeyAndShortForm(*OptionRunner).c_str(),
@@ -649,24 +1090,8 @@
               ;
             break;
-          case Atom:
-            ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(),
-                  DefaultValue.find(*OptionRunner) != DefaultValue.end() ?
-                        po::value< int >()->default_value(atoi(DefaultValue[*OptionRunner].c_str())) :
-                        po::value< int >(),
-                  getDescription(*OptionRunner).c_str())
-              ;
-            break;
-          case ListOfAtoms:
-            ListRunner->second->add_options()
-              (getKeyAndShortForm(*OptionRunner).c_str(),
-                  po::value< vector<int> >()->multitoken(),
-                  getDescription(*OptionRunner).c_str())
-              ;
-            break;
           case Element:
             ListRunner->second->add_options()
               (getKeyAndShortForm(*OptionRunner).c_str(),
-                  po::value< vector<int> >(),
+                  po::value< int >(),
                   getDescription(*OptionRunner).c_str())
               ;
@@ -681,5 +1106,5 @@
         }
       } else {
-        DoLog(0) && (Log() << Verbose(0) << "Adding option " << *OptionRunner << " to CommandLineParser." << endl);
+        DoLog(3) && (Log() << Verbose(3) << "Adding option " << *OptionRunner << " to CommandLineParser." << endl);
         ListRunner->second->add_options()
           (getKeyAndShortForm(*OptionRunner).c_str(), getDescription(*OptionRunner).c_str())
@@ -688,10 +1113,4 @@
     }
   }
-  // add positional arguments
-  for (set<string>::iterator OptionRunner = inputfile.begin(); OptionRunner != inputfile.end(); ++OptionRunner) {
-    DoLog(0) && (Log() << Verbose(0) << "Adding option " << *OptionRunner << " to positional CommandLineParser." << endl);
-    CommandLineParser::getInstance().inputfile.add((*OptionRunner).c_str(), -1);
-  }
-  cout << "Name for position 1: " << CommandLineParser::getInstance().inputfile.name_for_position(1) << endl;
 }
 
@@ -749,7 +1168,7 @@
  * \return type of the action
  */
-enum MapOfActions::OptionTypes MapOfActions::getValueType(string actionname)
-{
-  return TypeMap[actionname];
+std::string MapOfActions::getValueType(string actionname)
+{
+  return TypeMap[actionname]->name();
 }
 
Index: src/Actions/MapOfActions.hpp
===================================================================
--- src/Actions/MapOfActions.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MapOfActions.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -9,15 +9,28 @@
 #define MAPOFACTIONS_HPP_
 
-#include "Helpers/Assert.hpp"
 #include <boost/program_options.hpp>
+#include <boost/lexical_cast.hpp>
 
 #include <map>
 #include <set>
+#include <vector>
+#include <typeinfo>
+
+#include "Exceptions/IllegalTypeException.hpp"
+#include "Exceptions/MissingValueException.hpp"
+#include "Helpers/Assert.hpp"
+#include "Patterns/Singleton.hpp"
 
 class MapOfActionsTest;
 
-#include "Patterns/Singleton.hpp"
+class Box;
+class atom;
+class element;
+class molecule;
+class Vector;
 
 namespace po = boost::program_options;
+
+using boost::lexical_cast;
 
 /** Central class for adding functionality to the code.
@@ -123,5 +136,5 @@
   friend class MapOfActionsTest;
 public:
-  enum OptionTypes { None, Boolean, Integer, ListOfInts, Double, ListOfDoubles, String, ListOfString, Axis, Vector, Box, Molecule, ListOfMolecules, Atom, ListOfAtoms, Element, ListOfElements };
+  enum OptionTypes { None, Boolean, Integer, ListOfIntegers, Double, ListOfDoubles, String, ListOfStrings, Vector, ListOfVectors, Box, Molecule, ListOfMolecules, Atom, ListOfAtoms, Element, ListOfElements };
 
   // getter for the action descriptions and short forms
@@ -136,5 +149,5 @@
   bool hasValue(std::string actionname);
   bool isShortFormPresent(std::string shortform);
-  enum OptionTypes getValueType(std::string actionname);
+  std::string  getValueType(std::string actionname);
 
   std::set<std::string> generic;
@@ -150,4 +163,70 @@
   void populateActions();
 
+  bool isCurrentValuePresent(const char *name) const;
+  void queryCurrentValue(const char * name, class atom * &_T);
+  void queryCurrentValue(const char * name, const element * &_T);
+  void queryCurrentValue(const char * name, class molecule * &_T);
+  void queryCurrentValue(const char * name, class Box &_T);
+  void queryCurrentValue(const char * name, class Vector &_T);
+  void queryCurrentValue(const char * name, std::vector<atom *>&_T);
+  void queryCurrentValue(const char * name, std::vector<const element *>&_T);
+  void queryCurrentValue(const char * name, std::vector<molecule *>&_T);
+  template<typename T> void queryCurrentValue(const char * name, T &_T)
+  {
+    if (typeid( T ) == *TypeMap[name]) { // constructor of type_info is private, hence can only store by ref or ptr
+      if (CurrentValue.find(name) == CurrentValue.end())
+        throw MissingValueException(__FILE__, __LINE__);
+      _T = lexical_cast<T>(CurrentValue[name].c_str());
+      CurrentValue.erase(name);
+    } else
+      throw IllegalTypeException(__FILE__,__LINE__);
+  }
+  template<typename T> void queryCurrentValue(const char * name, std::vector<T> &_T)
+  {
+    T temp;
+    if (typeid( std::vector<T> ) == *TypeMap[name]) { // constructor of type_info is private, hence can only store by ref or ptr
+      if (CurrentValue.find(name) == CurrentValue.end())
+        throw MissingValueException(__FILE__, __LINE__);
+      std::istringstream stream(CurrentValue[name]);
+      CurrentValue.erase(name);
+      while (!stream.fail()) {
+        stream >> temp >> std::ws;
+        _T.push_back(temp);
+      }
+    } else
+      throw IllegalTypeException(__FILE__,__LINE__);
+  }
+
+  void setCurrentValue(const char * name, class atom * &_T);
+  void setCurrentValue(const char * name, const element * &_T);
+  void setCurrentValue(const char * name, class molecule * &_T);
+  void setCurrentValue(const char * name, class Box &_T);
+  void setCurrentValue(const char * name, class Vector &_T);
+  void setCurrentValue(const char * name, std::vector<atom *>&_T);
+  void setCurrentValue(const char * name, std::vector<const element *>&_T);
+  void setCurrentValue(const char * name, std::vector<molecule *>&_T);
+  template<class T> void setCurrentValue(const char * name, T &_T)
+  {
+    std::ostringstream stream;
+    if (typeid( T ) == *TypeMap[name]) {  // constructor of type_info is private, hence can only store by ref or ptr
+      stream << _T;
+      CurrentValue[name] = stream.str();
+    } else
+      throw IllegalTypeException(__FILE__,__LINE__);
+  }
+  template<class T> void setCurrentValue(const char * name, std::vector<T> &_T)
+  {
+    std::ostringstream stream;
+    if (typeid( std::vector<T> ) == *TypeMap[name]) {  // constructor of type_info is private, hence can only store by ref or ptr
+      std::ostringstream stream;
+      for (typename std::vector<T>::iterator iter = _T.begin(); iter != _T.end(); ++iter) {
+        stream << (*iter) << " ";
+      }
+      CurrentValue[name] = stream.str();
+    } else
+      throw IllegalTypeException(__FILE__,__LINE__);
+  }
+
+
 private:
   // private constructor and destructor
@@ -159,8 +238,9 @@
 
   // map of the action names and their description
-  std::map<std::string, std::string> DefaultValue;
+  std::map<std::string, std::string> CurrentValue;
   std::map<std::string, std::string> DescriptionMap;
   std::map<std::string, std::string> ShortFormMap;
-  std::map<std::string, enum OptionTypes > TypeMap;
+  std::map<std::string, const std::type_info * > TypeMap;
+  std::map<const std::type_info *, enum OptionTypes > TypeEnumMap;
 };
 
Index: src/Actions/MethodAction.cpp
===================================================================
--- src/Actions/MethodAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MethodAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -25,4 +30,9 @@
 MethodAction::~MethodAction()
 {}
+
+Dialog* MethodAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+  return dialog;
+}
 
 
Index: src/Actions/MethodAction.hpp
===================================================================
--- src/Actions/MethodAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MethodAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -25,4 +25,6 @@
   virtual bool shouldUndo();
 
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/MoleculeAction/BondFileAction.cpp
===================================================================
--- src/Actions/MoleculeAction/BondFileAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/BondFileAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,7 +6,17 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/BondFileAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Helpers/Log.hpp"
+#include "molecule.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
 
 #include <iostream>
@@ -18,14 +28,6 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
 
-#include "atom.hpp"
-#include "bondgraph.hpp"
-#include "config.hpp"
-#include "defs.hpp"
-#include "log.hpp"
-#include "molecule.hpp"
-#include "vector.hpp"
-#include "World.hpp"
 
 /****** MoleculeBondFileAction *****/
@@ -52,22 +54,32 @@
 {}
 
+void MoleculeBondFile(std::string &bondfile) {
+  ValueStorage::getInstance().setCurrentValue(MoleculeBondFileAction::NAME, bondfile);
+  ActionRegistry::getInstance().getActionByName(MoleculeBondFileAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* MoleculeBondFileAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr MoleculeBondFileAction::performCall() {
   string filename;
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   molecule *mol = NULL;
 
-  dialog->queryString(NAME, &filename, MapOfActions::getInstance().getDescription(NAME));
-  dialog->queryMolecule("molecule-by-id", &mol, MapOfActions::getInstance().getDescription("molecule-by-id"));
+  ValueStorage::getInstance().queryCurrentValue(NAME, filename);
 
-  if(dialog->display()) {
+  if(World::getInstance().countSelectedMolecules() == 1) {
+    mol = World::getInstance().beginMoleculeSelection()->second;
     DoLog(0) && (Log() << Verbose(0) << "Parsing bonds from " << filename << "." << endl);
     ifstream input(filename.c_str());
     mol->CreateAdjacencyListFromDbondFile(&input);
     input.close();
-    delete dialog;
     return Action::success;
-  }
-  delete dialog;
-  return Action::failure;
+  } else
+    return Action::failure;
 }
 
Index: src/Actions/MoleculeAction/BondFileAction.hpp
===================================================================
--- src/Actions/MoleculeAction/BondFileAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/BondFileAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,9 +10,13 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
+
 
 class MoleculeListClass;
 
+void MoleculeBondFile(std::string &bondfile);
+
 class MoleculeBondFileAction : public Action {
+  friend void MoleculeBondFile(std::string &bondfile);
+
 public:
   MoleculeBondFileAction();
@@ -23,4 +27,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/MoleculeAction/ChangeNameAction.cpp
===================================================================
--- src/Actions/MoleculeAction/ChangeNameAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/ChangeNameAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,7 +6,15 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/ChangeNameAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "atom.hpp"
+#include "molecule.hpp"
 
 #include <iostream>
@@ -17,8 +25,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
-
-#include "atom.hpp"
-#include "molecule.hpp"
+#include "Actions/ValueStorage.hpp"
 
 /****** MoleculeChangeNameAction *****/
@@ -45,20 +50,30 @@
 {}
 
+void MoleculeChangeName(std::string &name) {
+  ValueStorage::getInstance().setCurrentValue(MoleculeChangeNameAction::NAME, name);
+  ActionRegistry::getInstance().getActionByName(MoleculeChangeNameAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* MoleculeChangeNameAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr MoleculeChangeNameAction::performCall() {
   string filename;
   molecule *mol = NULL;
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
 
-  dialog->queryMolecule(NAME, &mol, MapOfActions::getInstance().getDescription(NAME));
-  dialog->queryString("Enter name: ",&filename);
+  ValueStorage::getInstance().queryCurrentValue(NAME, filename);
 
-  if(dialog->display()) {
+  if (World::getInstance().countSelectedMolecules() == 1) {
+    mol = World::getInstance().beginMoleculeSelection()->second;
     string oldName = mol->getName();
     mol->setName(filename);
-    delete dialog;
     return Action::state_ptr(new MoleculeChangeNameState(mol,oldName));
-  }
-  delete dialog;
-  return Action::failure;
+  } else
+    return Action::failure;
 }
 
Index: src/Actions/MoleculeAction/ChangeNameAction.hpp
===================================================================
--- src/Actions/MoleculeAction/ChangeNameAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/ChangeNameAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,9 +10,13 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
+
 
 class MoleculeListClass;
 
+void MoleculeChangeName(std::string &name);
+
 class MoleculeChangeNameAction : public Action {
+  friend void MoleculeChangeName(std::string &name);
+
 public:
   MoleculeChangeNameAction();
@@ -23,4 +27,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
